#include "CEventQueue.h"

CEventQueue::CEventQueue()
{
	num = 0;
	head = 0;
	butt = 0;
}

CEventQueue::~CEventQueue()
{
	Element* e;
	while(butt != head)
	{
		e = butt->prev;
		delete butt;
	}
	delete head;
}

void CEventQueue::add(CEvent* evt)
{	
	Element* e = new Element();
	e->next = 0;
	if (butt != 0)
	{
		e->data = evt;
		butt->next = e;
		e->prev = butt;
		butt = e; 
	}
	else
	{
		e->prev = 0;
		e->data = evt;
		head = e;
		butt = e;
	}
	num++;
}

CEvent* CEventQueue::get()
{
	if (head != 0)
	{
		CEvent* e = head->data;
		Element* c = head->next;
		delete head;
		head = c;
		if (c == 0) butt = 0;
		num--;
		return e;
	}
	else
		return 0;
}