#include "CMonstr.h"

CMonstr::CMonstr()
{

}

CMonstr::~CMonstr()
{

}

CMonstr::CMonstr(int xp,int yp,int t,CMap* m)
{
	x = xp;
	y = yp;
	Px = 0;
	Py = 0;
	dir = 1;
	anim = 0;
	tAnim = MONSTR_ANIM_SPEED;
	tBlink = 0;
	tDie = 0;
	lives = 3;
	type = t;
	timer = 0;
	die = false;
	blink = false;
	Y0 = 0;
	Y1 = 0;
	Y2 = 0;
	Y3 = 0;
	Y4 = 0;
	map = new CMapAccess(m);
}

void CMonstr::CheckBombExplosion(CBomb* bomb)
{
	int xb = bomb->x;
	int yb = bomb->y;
	int pb = bomb->power;
	bool lt = true;	bool rt = true;	bool up = true;	bool dn = true;
	for(int i=1;i<=pb;i++)
	{	
		if (map->checkMapPos(xb + i,yb)>=3) rt = false;
		if (map->checkMapPos(xb - i,yb)>=3) lt = false;
		if (map->checkMapPos(xb,yb - i)>=3) up = false;
		if (map->checkMapPos(xb,yb + i)>=3) dn = false;
		
		if (dn && (xb == x && yb + i == y))	
		{
			CEvent *e = new CEvent(eMONSTR_HIT);
			A0(e);
			delete e;
		}
		if (rt && (xb + i == x && yb == y))
		{
			CEvent *e = new CEvent(eMONSTR_HIT);
			A0(e);
			delete e;
		}
		if (lt && (xb - i == x && yb == y))
		{
			CEvent *e = new CEvent(eMONSTR_HIT);
			A0(e);
			delete e;
		}
		if (up && (xb == x && yb - i == y))
		{
			CEvent *e = new CEvent(eMONSTR_HIT);
			A0(e);
			delete e;
		}
	}	
}

void CMonstr::A0(CEvent *e)
{
/*	if (e != 0) switch (Y0)
	{
	case 0:       //alive
		switch(e->num)
		{
		case eMONSTR_HIT:
			if (lives > 1)
			{
				Y0 = 1; 
				tBlink = MONSTR_BLINK_ANIM_SPEED; 
				timer = MONSTR_BLINK_TIME; 
				blink = true;
			}
			else 
			{
				Y0 = 2; 
				tDie = MONSTR_DIE_ANIM_SPEED;
				die = true;
			}
			A2();
			A1();
			break;
		case eMONSTR_PAINT:
			map->addObject(
				MAP_OFFSET_X + x * CELL_SIZE + CELL_SIZE/2 + Px - PARF_WIDTH/2,
				MAP_OFFSET_Y + (y + 1) * CELL_SIZE - PARF_HEIGHT + Py,
				MAX_BOMBS_ON_MAP + z + 1,
				PARF_WIDTH,PARF_HEIGHT,3,(dir-1)*3 + anim);
			break;
		case eMONSTR_YOU:
			A2();
			break;
	case 1:		  //after hit me
		if (timer > 0) 
		{
			timer--;
			A4();
			A2();
			A1();
		}
		if (timer == 0) 
		{
			blink = false;
			Y0 = 0;
		}
		break;	 
	case 2:		  //i am dying		
		A3();
		break;
	case 3:       //  
		break;
	}
	*/
}

void CMonstr::A1()
{
	switch(Y1)
	{
	case 0:
		if (tAnim == 0)
		{
			anim = 1;
			tAnim = MONSTR_ANIM_SPEED;
			Y1 = 1;
		} else
			tAnim--;
		break;
	case 1:
		if (tAnim == 0)
		{
			anim = 0;
			tAnim = MONSTR_ANIM_SPEED;
			Y1 = 2;
		} else
			tAnim--;
		break;
	case 2:
		if (tAnim == 0)
		{
			anim = 2;
			tAnim = MONSTR_ANIM_SPEED;
			Y1 = 3;
		} else
			tAnim--;
		break;
	case 3:
		if (tAnim == 0)
		{
			anim = 0;
			tAnim = MONSTR_ANIM_SPEED;
			Y1 = 0;
		} else
			tAnim--;
		break;
	}
}

void CMonstr::A3()
{
	switch(Y3)
	{
	case 0:
		if (tDie == 0)
		{
			anim = 1;
			tDie = MONSTR_DIE_ANIM_SPEED;
			Y3 = 1;
		} else
			tDie--;
		break;
	case 1:
		if (tDie == 0)
		{
			anim = 2;
			tDie = MONSTR_DIE_ANIM_SPEED;
			Y3 = 2;
		} else
			tDie--;
		break;
	case 2:
		if (tDie == 0)
		{
			anim = 3;
			tDie = MONSTR_DIE_ANIM_SPEED;
			Y3 = 3;
		} else
			tDie--;
		break;
	case 3:
		if (tDie == 0)
		{
			anim = 4;
			tDie = MONSTR_DIE_ANIM_SPEED;
			Y3 = 4;
		} else
			tDie--;
		break;
	case 4:
		if (tDie == 0)
		{
			anim = 5;
			tDie = MONSTR_DIE_ANIM_SPEED;
			Y3 = 5;
		} else
			tDie--;
		break;
	case 5:
		if (tDie == 0)
		{
			CEvent *e1 = new CEvent(eMONSTR_DIE_END,this);
			SendEvent(e1);
			anim = 1;
			Y3 = 8;
		} else
			tDie--;
		break;
	case 8:
		break;
	}
}

void CMonstr::A4()
{
	switch(Y4)
	{
	case 0:
		if (tBlink>0)
		{
			tBlink--;
		}
		if (tBlink == 0)
		{
			tBlink == PLAYER_BLINK_ANIM_SPEED;
			blink = false;
			Y4 = 1;
		}
		break;
	case 1:
		if (tBlink>0)
		{
			tBlink--;
		}
		if (tBlink == 0)
		{
			tBlink == PLAYER_BLINK_ANIM_SPEED;
			blink = true;
			Y4 = 0;
		}
		break;
	}
}

#define x1   checkMap(-1,0)
#define x2   checkMap(0,1)
#define x3   checkMap(1,0)
#define x4   checkMap(0,-1)   

void CMonstr::A2()
{
	if (Px==0 && Py==0)
	{
		int r = (rand()%3) + 1;
		switch (Y2)
		{
			case 0:			//
				if (x1 && !x2 && !x3 && !x4 && r==1) 
				{
					Px--; 
					Y2 = 1;
				} else 
				if (!x1 && x2 && !x3 && !x4 && r==2) 
				{
					Py++; 
					Y2 = 2;
				} else
				if (!x1 && !x2 && x3 && !x4 && r==3) 
				{
					Px++; 
					Y2 = 3;
				} else
				if (!x1 && !x2 && !x3 && x4 && r==4) 
				{
					Py--; 
					Y2 = 4;
				}
				break;
			case 1:			// 
				if (!x1 && !x2 && !x3 && !x4) 
				{
					Y2 = 0;
				} else
				if (x2 && r==2) 
				{
					Py++; 
					Y2 = 2;
				} else
				if (x4 && r==4) 
				{
					Py--; 
					Y2 = 4;
				} else
				if (x3 && r==3) 
				{
					Px++; 
					Y2 = 3;
				}
				break;		
			case 2:			// 
				if (!x1 && !x2 && !x3 && !x4) 
				{
					Y2 = 0;
				} else
				if (x1 && r==1) 
				{
					Px--; 
					dir = 1; 
					Y2 = 1;
				} else
				if (x4 && r==4) 
				{
					Py--; 
					Y2 = 4;
				} else
				if (x3 && r==3) 
				{
					Px++; 
					Y2 = 3;
				}
				break;
			case 3:			// 
				if (!x1 && !x2 && !x3 && !x4) 
				{
					Y2 = 0;
				} else
				if (x2 && r==2) 
				{
					Py++; 
					Y2 = 2;
				} else
				if (x4 && r==4) 
				{
					Py--; 
					Y2 = 4;
				} else
				if (x1 && r==1) 
				{
					Px--; 
					Y2 = 1;
				}
				break;
			case 4:			// 
				if (!x1 && !x2 && !x3 && !x4) 
				{
					Y2 = 0;
				} else
				if (x2 && r==2) 
				{
					Py++; 
					Y2 = 2;
				} else
				if (x1 && r==1) 
				{
					Px--; 
					Y2 = 1;
				} else
				if (x3 && r==3) 
				{
					Px++; 
					Y2 = 3;
				}
				break;
		}
	}
	else
	{
		switch (Y2)
		{
		case 1: 
			Px--;
			break;
		case 2:
			Py++;
			break;
		case 3:
			Px++;
			break;
		case 4:
			Py--;
			break;
		}
	}

}

bool CMonstr::checkMap(int x,int y)
{
	int xp = CMonstr::x + x;
	int yp = CMonstr::y + y;
	if (xp>=0 && yp>=0 && xp<MAP_WIDTH && yp<MAP_HEIGHT)
		return map->checkMapPos(CMonstr::x + x, CMonstr::y + y) == 0;
	else 
		return false;
}

bool CMonstr::checkMove()
{
	if (Px > CELL_SIZE/2)
	{
		x++;
		Px -= CELL_SIZE;
	}
	if (Py > CELL_SIZE/2)
	{
		y++;
		Py -= CELL_SIZE;
	}
	if (Px < -CELL_SIZE/2)
	{
		x--;
		Px += CELL_SIZE;
	}
	if (Py < -CELL_SIZE/2)
	{
		y--;
		Py += CELL_SIZE;
	}
	return true;
}


bool CMonstr::TranslateEvent(CEvent *e)
{
	if (e != 0)
	{
		switch(e->num)
		{
		case eBOMB_EXPLODE_BEGIN:
			CheckBombExplosion(e->bmb);
			break;
		}
	}
	return true;
}

void CMonstr::You()
{
	A0(0);
}

void CMonstr::Paint(int z)
{
}

