#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "defines.h"
#include "events.h"
#include "CGame.h"
#include "CEventQueue.h"

HINSTANCE hInst;								// current instance
HWND hWnd;

ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
VOID    CALLBACK	MyTimer(HWND hwnd, UINT uMsg, UINT_PTR idEvent,DWORD dwTime);

int					SendEvent(CEvent* e);
int					GetEvent(CEvent* e);
int					nowPaint = 1;

CGame* game = 0;
CEventQueue* queue = 0; 


//************* Events *************

int SendEvent(CEvent* e)
{
	queue->add(e);
	return queue->num;	
}

CEvent* GetEvent()
{
	return queue->get();
}


//*************** Main ****************

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	int i;
	game = new CGame();
	srand( (unsigned)time( NULL ) );
	queue = new CEventQueue();
	game->LoadLevel(0);
	
	game->GetInput()->SetPlayerButtons(game->GetPlayer(0),VK_LEFT,VK_RIGHT,VK_UP,VK_DOWN,VK_O,VK_P);
	game->GetInput()->SetPlayerButtons(game->GetPlayer(1),VK_S,VK_F,VK_E,VK_D,VK_Q,VK_W);

	MSG msg;
	CEvent* evt = 0;

	MyRegisterClass(hInstance);

	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}
	if (!SetTimer(hWnd,1,1,NULL))
	{
		MessageBox(hWnd, "Fucking Timer", "", MB_OK);
		return false;
	}
	while (GetMessage(&msg, NULL,0,0)) 
	{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			while (queue->num > 0)
			{
				evt = GetEvent();
				game->TranslateEvent(evt);
				delete evt;
				evt = 0;
			};
			game->You();
			game->Paint(0);
			//if (nowPaint == 1) 			{				nowPaint--;			}
	}

	delete game;
	delete queue;
	return msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= "AUTOMATic BOMBER";
	wcex.lpszClassName	= "BOMBER";
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(
	   "BOMBER",
	   "AUTOMATic BOMBER", 
	   WS_OVERLAPPEDWINDOW,
	   CW_USEDEFAULT, 
	   0, 
	   CW_USEDEFAULT, 
	   0, 
	   NULL, 
	   NULL, 
	   hInstance, 
	   NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
//   ShowCursor(0);
   if (!game->InitScreen (hWnd))
	   return false;
 
   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
    PAINTSTRUCT ps; 
	RECT r;
	char str[80];
	switch (message) 
	{
		case WM_PAINT:
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_KEYDOWN:
			game->DecodeKey(wParam,eKEY_DOWN);
			break;
		case WM_KEYUP:
			game->DecodeKey(wParam,eKEY_UP);
			break;
		case WM_TIMER:
			nowPaint = 1;
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

VOID CALLBACK MyTimer(HWND hwnd, UINT uMsg, UINT_PTR idEvent,DWORD dwTime)
{
	if (idEvent == 1) nowPaint = 1;
}

