#include "CKeyboard.h"
#include "events.h"
#include <windows.h>

CKeyboard::CKeyboard()
{
	ClearButtons();
}

CKeyboard::~CKeyboard()
{

}

void CKeyboard::decodeKey(long int k,int f)
{
	if (buttons[k]!=0)
	{
		CEvent* e = new CEvent((f == eKEY_DOWN)? ePLAYER_KEY_DOWN : ePLAYER_KEY_UP, buttons[k], k);
		SendEvent(e);
		return;
	}
	switch(k)
	{
		case VK_ESCAPE:
			PostQuitMessage(0);
		break;
	}
}

bool CKeyboard::SetPlayerButtons(CPlayer* p,long kleft,long kright,long kup,long kdown,long kput,long kexp)
{
	if (p != 0)
	{	
		buttons[kleft] = p;
		buttons[kright] = p;
		buttons[kup] = p;
		buttons[kdown] = p;
		buttons[kput] = p;
		buttons[kexp] = p;
		p->SetButtons(kleft,kright,kup,kdown,kput,kexp);
		return true;
	}
	return false;
}

void CKeyboard::ClearButtons()
{
	for (int i=0;i<=255;i++) buttons[i] = (CPlayer*)0;
}
